# Stick to /usr/lib/timidity on any platform
# XXX probably better in /usr/share/timidity for arch independent data
# but it's not worth splitting that much
%define timiditydir	%{_prefix}/lib/timidity

#
# When big change is involved (e.g. timidity.cfg change location),
# so that new timidity binray and old patch RPM won't work together,
# increment this number by 1 for all timidity related RPMs
#
%define patch_pkg_version 2

#
# NOTE: When updating config for midia patch set, please refresh both
# config file included here and the one in patch pkg
#

Summary:	MIDI to WAVE converter and player
Name:		TiMidity++
Version:	2.14.0
%define subrel	1
Release:	%mkrel 6
URL:		http://timidity.sourceforge.net/
License:	GPLv2+
Group:		Sound/Midi
Source0:	http://download.sourceforge.net/timidity/%{name}-%{version}.tar.xz
Source1:	http://www.timidity.jp/dist/cfg/timidity.cfg
Source2:	timidity-emacs-mode.el
Source3:	timidity.README.mga
# (Abel) change default config path to /etc/timidity/timidity.cfg
Patch0:		timidity-2.13.2-default-config-path.patch
Patch1:		timidity-2.13.2-tcl-legacy.patch
Patch2:		timidity-2.14.0-opensuse-zero-division-fix.patch
Patch3:		timidity-2.14.0-opensuse-out-of-bound-access-fix.patch
Requires:	timidity-instruments = %{patch_pkg_version}
BuildRequires:	alsa-lib-devel
BuildRequires:	autoconf
BuildRequires:	emacs-bin
BuildRequires:	gtk2-devel
BuildRequires:	jackit-devel
BuildRequires:	lesstif-devel
BuildRequires:	libao-devel
BuildRequires:	libflac-devel >= 1.1.3
BuildRequires:	liboggflac-devel
BuildRequires:	ncurses-devel
BuildRequires:	oggvorbis-devel
BuildRequires:	portaudio-devel
BuildRequires:	speex-devel
BuildRequires:	tcl-devel
BuildRequires:	tk-devel
BuildRequires:	libxaw-devel
BuildRequires:	slang-devel
BuildRequires:	imagemagick
BuildConflicts:	Xaw3d-devel


%description
TiMidity is a MIDI to WAVE converter and player that uses Gravis 
Ultrasound(tm) or SoundFont(tm) patch files to generate digital audio data
from general MIDI files. The audio data can be played through any 
sound device or stored on disk.

%package	interfaces-extra
Summary:	Extra GUI/text mode interfaces for TiMidity
Group:		Sound/Midi
Requires:	%{name} = %{version}-%{release}
Requires:	emacs-bin

%description	interfaces-extra
TiMidity is a MIDI to WAVE converter and player that uses Gravis 
Ultrasound(tm) or SoundFont(tm) patch files to generate digital audio data
from general MIDI files. The audio data can be played through any 
sound device or stored on disk.

Install this if you want to use TiMidity under other interfaces, such as
Motif(or Lesstif), Tcl/Tk, emacs etc.

%prep
%setup -q
%patch0 -p1 -b .default-path
%patch1 -p0 -b .tcl_legacy
%patch2 -p1 -b .CVE-2017-11546
%patch3 -p1 -b .CVE-2017-11547

%build
autoconf

# little ugly trick to force install of tclIndex, running wish requires
# X display
touch interface/tclIndex


export SHLDFLAGS=`echo '%{ldflags}'|sed -e 's/-Wl,--no-undefined//'`
%configure2_5x \
	--enable-audio=oss,alsa,portaudio,jack,ao,vorbis,flac,speex \
	--enable-dynamic=dynamic,ncurses,slang,motif,tcltk,emacs,xaw,xskin,gtk \
	--enable-interface=alsaseq \
	--enable-network \
	--enable-server
%make LDFLAGS="-lFLAC"

%install
%makeinstall_std
install -d %{buildroot}%{_datadir}/timidity
install -m644 %{SOURCE1} -D %{buildroot}%{_sysconfdir}/timidity/timidity-custom.cfg
install -d %{buildroot}%{_datadir}/applications
cat <<EOF > %{buildroot}%{_datadir}/applications/%{name}.desktop
[Desktop Entry]
Name=TiMidity++
GenericName=MIDI file player
GenericName[ar]=مشغل ملفات MIDI
GenericName[az]=MIDI fayl çalğıcısı
GenericName[bg]=MIDI плеър
GenericName[bn]=মিডি ফাইল বাদক
GenericName[br]=Ur soner a restr MIDI
GenericName[bs]=Svirač MIDI datoteka
GenericName[ca]=Reproductor de fitxers MIDI
GenericName[cs]=Přehrávač hudebních souborů MIDI
GenericName[cy]=Chwaraewr ffeil MIDI
GenericName[da]=MIDI-musikafspiller
GenericName[de]=MIDI Dateienspieler
GenericName[el]=Πρόγραμμα αναπαραγωγής MIDI
GenericName[es]=Reproductor de archivos MIDI
GenericName[et]=MIDI failide mängija
GenericName[eu]=MIDI fitxategi-erreproduzigailua
GenericName[fa]=پخشگر پرونده MIDI
GenericName[fi]=MIDI-soitin
GenericName[fr]=Lecteur de fichiers MIDI
GenericName[gl]=Reproductor de ficheiros MIDI
GenericName[he]=נגן קבצי מידי
GenericName[hi]=मीडी फ़ाइल प्लेयर
GenericName[hu]=MIDI-fájllejátszó
GenericName[id]=Pemutar file MIDI
GenericName[is]=MIDI skráa spilari
GenericName[it]=Riproduttore di file MIDI
GenericName[ja]=MIDI プレーヤー
GenericName[ky]=MIDI файлын ойноткучу
GenericName[mk]=Плеер на „MIDI“ датотеки
GenericName[mt]=Programm biex iddoqq mużika MIDI
GenericName[nb]=MIDI-fil avspiller
GenericName[nl]=MIDI bestandsspeler
GenericName[nn]=MIDI-filspelar
GenericName[pl]=Odtwarzacz plików MIDI
GenericName[pt]=Leitor de ficheiros MIDI
GenericName[pt_BR]=Player de arquivos MIDI
GenericName[ro]=Lector de fișiere MIDI
GenericName[ru]=Проигрыватель MIDI-файлов
GenericName[sc]=Sonadori de file MIDI
GenericName[sk]=Prehrávač MIDI hudby
GenericName[sl]=Predvajalnik MIDI datotek
GenericName[sq]=Lexues skedaresh MIDI
GenericName[sv]=Spelar MIDI-filer
GenericName[tg]=Бозигари MIDI файл
GenericName[th]=โปรแกรมเล่นไฟล์ MIDI
GenericName[tl]=Tagapagpatugtog ng MIDI file
GenericName[tr]=MIDI dosya çalıcı
GenericName[uk]=Програвач файлів MIDI
GenericName[uz]=MIDI fayl pleyer
GenericName[uz@cyrillic]=MIDI файл плейер
GenericName[vi]=Trình chơi tập tin MIDI
GenericName[wa]=Djouweu di fitchîs MIDI
GenericName[zh_CN]=MIDI 文件播放机
GenericName[zh_TW]=MIDI 音樂播放程式
Comment=A midi to wav converter and midi file player
Comment[de]=Ein Midi-zu-Wav-Konverter und Midi-Player
Comment[ru]=Плейер MIDI-файлов и конвертор в WAV
Exec=timidity -ig
Icon=%{name}
Terminal=false
Type=Application
StartupNotify=true
Categories=Audio;Midi;
EOF

mkdir -p %{buildroot}%{_iconsdir}/hicolor/48x48/apps
convert interface/pixmaps/timidity.xpm %{buildroot}%{_iconsdir}/hicolor/48x48/apps/%{name}.png

# emacs mode
install -m644 %{SOURCE2} -D %{buildroot}%{_sysconfdir}/emacs/site-start.d/timidity.el

# japanese manpages
install -m644 doc/ja_JP.eucJP/timidity.1 -D %{buildroot}%{_mandir}/ja/man1/timidity.1
install -m644 doc/ja_JP.eucJP/timidity.cfg.5 %{buildroot}%{_mandir}/ja/man1/timidity.cfg.5

%postun
if [ "$1" = "0" ]; then
%{_sbindir}/update-alternatives --remove timidity.cfg %{_sysconfdir}/timidity/timidity-custom.cfg
fi

%triggerpostun -- %{name} <= 2.13.2-22
%{_sbindir}/update-alternatives --install %{_sysconfdir}/timidity/timidity.cfg timidity.cfg %{_sysconfdir}/timidity/timidity-custom.cfg 10

%files
%doc AUTHORS ChangeLog INSTALL NEWS README doc/C/FAQ
%doc doc/C/README.{alsaseq,dl,sf,m2m,mts}
%config(noreplace) %{_sysconfdir}/timidity
%{_bindir}/timidity
%{_mandir}/man?/timidity*
%lang(ja) %{_mandir}/ja/man?/*
%{_datadir}/timidity
%dir %{timiditydir}
%{timiditydir}/if_gtk.so
%{timiditydir}/if_ncurses.so
%{_datadir}/applications/%{name}.desktop
%{_iconsdir}/hicolor/*/apps/%{name}.png

%files interfaces-extra
%doc doc/C/README.{tk,xaw,xskin}
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/*.el
%{timiditydir}/if_emacs.so
%{timiditydir}/if_motif.so
%{timiditydir}/if_slang.so
%{timiditydir}/if_tcltk.so
%{timiditydir}/if_xaw.so
%{timiditydir}/if_xskin.so
%{_datadir}/emacs/site-lisp/*.el
%{timiditydir}/*.tcl
%{timiditydir}/tclIndex
%{timiditydir}/bitmaps


%changelog
* Sun Feb 25 2018 luigiwalser <luigiwalser> 2.14.0-6.1.mga5
+ Revision: 1205083
- add patches from opensuse to fix CVE-2017-11546 and CVE-2017-11547

* Thu Nov 27 2014 alexl <alexl> 2.14.0-6.mga5
+ Revision: 799494
- added GenericName and new Comment
- translated desktop file

* Wed Oct 15 2014 umeabot <umeabot> 2.14.0-5.mga5
+ Revision: 741074
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 2.14.0-4.mga5
+ Revision: 677662
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 2.14.0-3.mga4
+ Revision: 528434
- Mageia 4 Mass Rebuild

* Wed Jun 19 2013 dams <dams> 2.14.0-2.mga4
+ Revision: 445039
- clean specfile
- remove icons as sources and use convert on the xpm file
- now tarball is .tar.xz

* Sun Jun 16 2013 luigiwalser <luigiwalser> 2.14.0-1.mga4
+ Revision: 443561
- 2.14.0
- remove patches 1, 2, 3, 4, 5, 6, 7, and 9 (fixed upstream)

* Fri Jan 11 2013 umeabot <umeabot> 2.13.2-35.mga3
+ Revision: 345138
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Nov 20 2012 barjac <barjac> 2.13.2-34.mga3
+ Revision: 319889
- Changed group to new policy
- minor spec clean

* Fri Nov 04 2011 fwang <fwang> 2.13.2-32.mga2
+ Revision: 162630
- drop empty post
- build with correct ldflags

* Sat Jul 02 2011 fwang <fwang> 2.13.2-31.mga2
+ Revision: 117319
- rebuild for new tcl

* Thu Mar 03 2011 ahmad <ahmad> 2.13.2-30.mga1
+ Revision: 62756
- drop esound-devel (phasing out esound from the distro)
- drop nas-devel (does any one still use nas sound?)
- rename the .desktop file, and the README file

* Mon Jan 24 2011 ennael <ennael> 2.13.2-29.mga1
+ Revision: 36774
- remove mdkversion
- imported package TiMidity++


* Sun Mar 28 2010 Funda Wang <fwang@mandriva.org> 2.13.2-29mdv2010.1
+ Revision: 528353
- rebuild

* Tue Mar 16 2010 Oden Eriksson <oeriksson@mandriva.com> 2.13.2-28mdv2010.1
+ Revision: 521913
- rebuilt for 2010.1

* Sun Aug 09 2009 Oden Eriksson <oeriksson@mandriva.com> 2.13.2-27mdv2010.0
+ Revision: 413014
- rebuild

* Tue Mar 03 2009 Guillaume Rousse <guillomovitch@mandriva.org> 2.13.2-26mdv2009.1
+ Revision: 347818
- fix x86_64 build dependencies
- rebuild for latest tk libs

  + Götz Waschk <waschk@mandriva.org>
    - fix patch 9

  + Helio Chissini de Castro <helio@mandriva.com>
    - Adios arts
    - Fix TCL legacy build
    - Fix wformat errors

* Fri Jul 04 2008 Oden Eriksson <oeriksson@mandriva.com> 2.13.2-25mdv2009.0
+ Revision: 231808
- bump release
- fix build

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas

* Fri Jan 04 2008 Götz Waschk <waschk@mandriva.org> 2.13.2-23mdv2008.1
+ Revision: 144831
- fix alternative removal on postun
- update trigger

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Thu Dec 20 2007 Adam Williamson <awilliamson@mandriva.org> 2.13.2-22mdv2008.1
+ Revision: 135392
- drop bogus requires on tclx allowing it to be removed from the distro
- don't package COPYING
- new license policy

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Fri Sep 07 2007 Anssi Hannula <anssi@mandriva.org> 2.13.2-21mdv2008.0
+ Revision: 82049
- rebuild for new soname of tcl

  + Thierry Vignaud <tv@mandriva.org>
    - kill desktop-file-validate's 'warning: key "Encoding" in group "Desktop Entry" is deprecated'

* Mon Aug 20 2007 Oden Eriksson <oeriksson@mandriva.com> 2.13.2-20mdv2008.0
+ Revision: 67908
- rebuilt against new portaudio libs

* Fri Jul 20 2007 Adam Williamson <awilliamson@mandriva.org> 2.13.2-19mdv2008.0
+ Revision: 53987
- rebuild against new lesstif
- update icon cache in %%post
- no need to mkdir if you're using install -D
- drop X-Mandriva menu category
- buildrequires autoconf

* Fri Jun 01 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.13.2-18mdv2008.0
+ Revision: 34274
- Removed old menu, placed icons in directories following
  freedesktop.org standard.


* Wed Dec 13 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 2.13.2-17mdv2007.0
+ Revision: 96138
- Fix flac mess
- U?\195pdate buildrequires for libflac
- add new flac patch

* Fri Oct 13 2006 Nicolas Lécureuil <neoclust@mandriva.org> 2.13.2-16mdv2007.1
+ Revision: 63854
- increase release
- Fix patches
-  Fix Build for portaudio V19
- Import TiMidity++

* Tue Sep 12 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 2.13.2-15mdv2007.0
- force linking against nas with -laudio to fix build on x86_64

* Tue Aug 29 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 2.13.2-14mdv2007.0
- build against x.org's xaw, not Xaw3d
- xdg menu
- cosmetics

* Thu Jun 08 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 2.13.2-13mdv2007.0
- fix build of nas against new modular x

* Wed Feb 15 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 2.13.2-12mdk
- buildRequires: tcl tk => libtcl-devel libtk-devel

* Sun Jan 01 2006 Oden Eriksson <oeriksson@mandriva.com> 2.13.2-11mdk
- rebuilt against soname aware deps

* Fri Sep 02 2005 Nicolas Lécureuil <neoclust@mandriva.org> 2.13.2-10mdk
- Removing Requires as it is still done ( but i have not found 
		yet how to really fix this! any ideas ?)
	- close ticket #18121

* Wed Aug 31 2005 Nicolas Lécureuil <neoclust@mandriva.org> 2.13.2-9mdk
- Fix Requires

* Fri Aug 05 2005 Nicolas Lécureuil <neoclust@mandriva.org> 2.13.2-8mdk
- Fix Build for gcc4

* Sun May 01 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 2.13.2-7mdk
- add BuildRequires: tcl liboggflac-devel

* Sat Apr 30 2005 Stew Benedict <sbenedict@mandriva.com> 2.13.2-6mdk
- rebuild for new libFLAC

* Thu Mar 10 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.13.2-5mdk
- stick to timidity data in /usr/lib/timidity

* Tue Feb 22 2005 Abel Cheung <deaddog@mandrake.org> 2.13.2-4mdk
- assorted CVS fixes

* Sun Feb 20 2005 Abel Cheung <deaddog@mandrake.org> 2.13.2-3mdk
- Rebuild to fix changelog

* Sun Feb 20 2005 Abel Cheung <deaddog@mandrake.org> 2.13.2-2mdk
- *NOTE: Please only modify /etc/timidity/timidity-custom.cfg in the future
  and use update-alternatives to set it to manual mode, if you want to
  use your own patches and soundfonts
- Tidy up this poor forgotten child
- P0: Use /etc/timidity/timidity.cfg as default config location
- P1: Fix speex header detection
- P2: Fix default program path for emacs inteface and install emacs file
      when dynamic module is enabled
- P3: Fix wishx path in tcl scripts
- S2: Add emacs mode file
- Make GUI interface modular
- Split some interfaces into subpackage to reduce dependency
- Include freepats config as a template into TiMidity, so that people can
  use it as basis, and modify it to suite their own taste

* Fri Dec 03 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.13.2-1mdk
- 2.13.2
- from UTUMI Hirosi <utuhiro78@yahoo.co.jp>:
	o new release
	o add --enable-xaw, --enable-audio=vorbis
	o (try $ timidity -iat)
	o modify BuildRequires for --enable-xaw and --enable-audio=vorbis
	o modify timidity.cfg (Source1) to reduce cpu usage
	o (disable chorus, resample, reverb)

* Fri Jul 23 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.13.1-0.cvs20040722.1mdk
- update to cvs to have gtk+ interface working

* Sun May 23 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.13.0-2mdk
- fix buildrequires

* Thu Apr 22 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.13.0-1mdk
- 2.13.0
- drop all patches (fixed upstream)
- fix buildrequires (lib64..)
- fix non-conffile-in-etc

